#include "delay.h"
#include "stdio.h"
#include "HMC5883L.h"
#include "stm32f4xx.h"
#include "First_Order_IIR_Filter.h"
#include "i2c.h"
#include "uart.h"
#include "FIRFilter.h"
float gx,gy,gz;
float gx_fil,gy_fil,gz_fil;
FirstOrderIIR filter_x,filter_y,filter_z;
FIRFilter FIR_Filter;
float gx_fir;
#define alpha (0.8)

/*
 * This function shall enable the FPU unit in cortex-M4/M7 based MCU
 * Note: Not all Cortex-M4/M7 has embedded FPU
 *
 * */
void enable_fpu()
	{
	SCB->CPACR |= ((3UL << 10*2)|(3UL << 11*2));

	}



int main(void)
	{
	enable_fpu();
	systick_init_ms(16000000);
	i2c_init();
	HMC5883L_Init(HMC5883L_RANGE_2_5GA);
	uart_Init();
	FirstOrderIIRFilter_Init(&filter_x, alpha);
	FirstOrderIIRFilter_Init(&filter_y, alpha);
	FirstOrderIIRFilter_Init(&filter_z, alpha);
	FIRFilter_Init(&FIR_Filter);
	while(1)
		{
		update_HMC5883L();
		gx=getGausX();
		gy=getGausY();
		gz=getGausZ();
		gx_fil=FIRFilter_Update(&FIR_Filter,gx);
		printf("%0.5f\t%0.5f\r\n",gx,gx_fil);
		delay(10);



		}




	}
